Index: i18n/en.ts
===================================================================
--- i18n/en.ts	(revision f0464480dbaed4452bd34ee92f4a2e0b8d6de557)
+++ i18n/en.ts	(revision 0bd0e1aca7e5525e6b1b8316b276d6ee9b8f99d1)
@@ -1,56 +1,56 @@
 <?xml version="1.0" encoding="utf-8"?>
 <!DOCTYPE TS>
-<TS version="2.0">
+<TS version="2.0" language="en" sourcelanguage="en">
 <defaultcodec>UTF-8</defaultcodec>
 <context>
     <name>CTSPModel</name>
     <message>
-        <location filename="../src/tspmodel.cpp" line="51"/>
+        <location filename="../src/tspmodel.cpp" line="121"/>
         <source>City %1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="53"/>
+        <location filename="../src/tspmodel.cpp" line="123"/>
         <source>%1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="147"/>
+        <location filename="../src/tspmodel.cpp" line="356"/>
         <source>Unexpected end of file.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="149"/>
+        <location filename="../src/tspmodel.cpp" line="358"/>
         <source>Corrupt data read. File possibly corrupted.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="151"/>
+        <location filename="../src/tspmodel.cpp" line="360"/>
         <source>Unknown error.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="153"/>
-        <location filename="../src/tspmodel.cpp" line="163"/>
-        <location filename="../src/tspmodel.cpp" line="187"/>
-        <location filename="../src/tspmodel.cpp" line="208"/>
-        <location filename="../src/tspmodel.cpp" line="222"/>
-        <location filename="../src/tspmodel.cpp" line="257"/>
-        <location filename="../src/tspmodel.cpp" line="267"/>
+        <location filename="../src/tspmodel.cpp" line="141"/>
+        <location filename="../src/tspmodel.cpp" line="165"/>
+        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
+        <location filename="../src/tspmodel.cpp" line="393"/>
+        <location filename="../src/tspmodel.cpp" line="428"/>
+        <location filename="../src/tspmodel.cpp" line="438"/>
         <source>Task Load</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="153"/>
-        <location filename="../src/tspmodel.cpp" line="187"/>
-        <location filename="../src/tspmodel.cpp" line="208"/>
-        <location filename="../src/tspmodel.cpp" line="222"/>
-        <location filename="../src/tspmodel.cpp" line="257"/>
-        <location filename="../src/tspmodel.cpp" line="267"/>
+        <location filename="../src/tspmodel.cpp" line="165"/>
+        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
+        <location filename="../src/tspmodel.cpp" line="393"/>
+        <location filename="../src/tspmodel.cpp" line="428"/>
+        <location filename="../src/tspmodel.cpp" line="438"/>
         <source>Unable to load task:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="163"/>
+        <location filename="../src/tspmodel.cpp" line="141"/>
         <source>Unable to open task file.
 Error: %1</source>
@@ -58,11 +58,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="187"/>
+        <location filename="../src/tspmodel.cpp" line="165"/>
         <source>Unknown file format or file is corrupted.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="208"/>
-        <location filename="../src/tspmodel.cpp" line="257"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
+        <location filename="../src/tspmodel.cpp" line="428"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -70,6 +70,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="222"/>
-        <location filename="../src/tspmodel.cpp" line="267"/>
+        <location filename="../src/tspmodel.cpp" line="393"/>
+        <location filename="../src/tspmodel.cpp" line="438"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -77,17 +77,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="303"/>
-        <location filename="../src/tspmodel.cpp" line="311"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="327"/>
-        <location filename="../src/tspmodel.cpp" line="335"/>
-        <location filename="../src/tspmodel.cpp" line="343"/>
-        <location filename="../src/tspmodel.cpp" line="351"/>
-        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="228"/>
+        <location filename="../src/tspmodel.cpp" line="236"/>
+        <location filename="../src/tspmodel.cpp" line="244"/>
+        <location filename="../src/tspmodel.cpp" line="252"/>
+        <location filename="../src/tspmodel.cpp" line="260"/>
+        <location filename="../src/tspmodel.cpp" line="268"/>
+        <location filename="../src/tspmodel.cpp" line="276"/>
+        <location filename="../src/tspmodel.cpp" line="287"/>
         <source>Task Save</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="303"/>
+        <location filename="../src/tspmodel.cpp" line="228"/>
         <source>Unable to create task file.
 Error: %1
@@ -96,11 +96,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="311"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="327"/>
-        <location filename="../src/tspmodel.cpp" line="335"/>
-        <location filename="../src/tspmodel.cpp" line="343"/>
-        <location filename="../src/tspmodel.cpp" line="351"/>
-        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="236"/>
+        <location filename="../src/tspmodel.cpp" line="244"/>
+        <location filename="../src/tspmodel.cpp" line="252"/>
+        <location filename="../src/tspmodel.cpp" line="260"/>
+        <location filename="../src/tspmodel.cpp" line="268"/>
+        <location filename="../src/tspmodel.cpp" line="276"/>
+        <location filename="../src/tspmodel.cpp" line="287"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -111,25 +111,25 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="138"/>
+        <location filename="../src/tspsolver.cpp" line="91"/>
         <source>%v of %m parts found</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="142"/>
+        <location filename="../src/tspsolver.cpp" line="95"/>
         <source>Calculating optimal route...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="143"/>
+        <location filename="../src/tspsolver.cpp" line="96"/>
         <source>Solution Progress</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="217"/>
+        <location filename="../src/tspsolver.cpp" line="170"/>
         <source>Solution Result</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="217"/>
+        <location filename="../src/tspsolver.cpp" line="170"/>
         <source>Unable to find solution.
 Maybe, this task has no solutions.</source>
@@ -137,7 +137,7 @@
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="235"/>
-        <location filename="../src/tspsolver.cpp" line="237"/>
-        <location filename="../src/tspsolver.cpp" line="240"/>
+        <location filename="../src/tspsolver.cpp" line="42"/>
+        <location filename="../src/tspsolver.cpp" line="44"/>
+        <location filename="../src/tspsolver.cpp" line="47"/>
         <source>City %1</source>
         <translation type="unfinished"></translation>
@@ -147,80 +147,99 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="546"/>
-        <location filename="../src/mainwindow.cpp" line="555"/>
+        <location filename="../src/mainwindow.cpp" line="278"/>
+        <location filename="../src/mainwindow.cpp" line="287"/>
         <source>Language change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="162"/>
+        <location filename="../src/mainwindow.cpp" line="622"/>
         <source>Unable to load translation language.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="204"/>
+        <location filename="../src/mainwindow.cpp" line="633"/>
         <source>Would you like to save changes in current task?</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="186"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
+        <location filename="../ui/mainwindow.ui" line="15"/>
+        <location filename="../src/mainwindow.cpp" line="716"/>
         <source>Travelling Salesman Problem</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="162"/>
+        <location filename="../src/mainwindow.cpp" line="622"/>
         <source>Language Change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="204"/>
+        <location filename="../src/mainwindow.cpp" line="633"/>
         <source>Unsaved Changes</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="234"/>
+        <location filename="../src/mainwindow.cpp" line="142"/>
         <source>All Supported Formats</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="235"/>
-        <location filename="../src/mainwindow.cpp" line="236"/>
+        <location filename="../src/mainwindow.cpp" line="143"/>
+        <location filename="../src/mainwindow.cpp" line="144"/>
         <source>%1 Task Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
-        <location filename="../src/mainwindow.cpp" line="286"/>
-        <location filename="../src/mainwindow.cpp" line="330"/>
+        <location filename="../src/mainwindow.cpp" line="145"/>
+        <location filename="../src/mainwindow.cpp" line="194"/>
+        <location filename="../src/mainwindow.cpp" line="693"/>
         <source>All Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="280"/>
+        <location filename="../src/mainwindow.cpp" line="188"/>
         <source>PDF Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="282"/>
+        <location filename="../src/mainwindow.cpp" line="190"/>
         <source>HTML Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="284"/>
+        <location filename="../src/mainwindow.cpp" line="192"/>
         <source>OpenDocument Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="329"/>
+        <location filename="../src/mainwindow.cpp" line="414"/>
+        <source>Selected candidate for branching: %1.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="414"/>
+        <location filename="../src/mainwindow.cpp" line="421"/>
+        <source>(%1;%2)</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message numerus="yes">
+        <location filename="../src/mainwindow.cpp" line="423"/>
+        <source>%n alternate candidate(s) for branching: %1.</source>
+        <translation>
+            <numerusform>%n alternate candidate for branching: %1.</numerusform>
+            <numerusform>%n alternate candidates for branching: %1.</numerusform>
+        </translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="692"/>
         <source>%1 Task File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="357"/>
+        <location filename="../src/mainwindow.cpp" line="265"/>
         <source>Settings Changed</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="357"/>
+        <location filename="../src/mainwindow.cpp" line="265"/>
         <source>You have changed color settings.
 Do you wish to apply them to current solution text?</source>
@@ -228,66 +247,66 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="439"/>
+        <location filename="../src/mainwindow.cpp" line="355"/>
+        <source>About TSPSG</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="389"/>
         <source>Data error</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="439"/>
+        <location filename="../src/mainwindow.cpp" line="389"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="452"/>
+        <location filename="../src/mainwindow.cpp" line="402"/>
         <source>Variant #%1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="453"/>
+        <location filename="../src/mainwindow.cpp" line="403"/>
         <source>Task:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="456"/>
-        <location filename="../src/mainwindow.cpp" line="487"/>
+        <location filename="../src/mainwindow.cpp" line="406"/>
+        <location filename="../src/mainwindow.cpp" line="447"/>
         <source>Solution of Variant #%1 task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="462"/>
+        <location filename="../src/mainwindow.cpp" line="412"/>
         <source>Step #%1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="465"/>
-        <source>This step has alternate candidates for branching.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="477"/>
+        <location filename="../src/mainwindow.cpp" line="436"/>
         <source>Optimal path:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="479"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Resulting path:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="481"/>
+        <location filename="../src/mainwindow.cpp" line="440"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="484"/>
+        <location filename="../src/mainwindow.cpp" line="443"/>
         <source>&lt;b&gt;WARNING!!!&lt;/b&gt;&lt;br&gt;This result is a record, but it may not be optimal.&lt;br&gt;Iterations need to be continued to check whether this result is optimal or get an optimal one.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="546"/>
+        <location filename="../src/mainwindow.cpp" line="278"/>
         <source>Language will be autodetected on next application start.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="555"/>
+        <location filename="../src/mainwindow.cpp" line="287"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -296,98 +315,98 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="255"/>
-        <location filename="../src/mainwindow.cpp" line="560"/>
-        <location filename="../src/mainwindow.h" line="79"/>
+        <location filename="../src/mainwindow.cpp" line="163"/>
+        <location filename="../src/mainwindow.cpp" line="292"/>
+        <location filename="../src/mainwindow.h" line="97"/>
         <source>Untitled</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="44"/>
+        <location filename="../ui/mainwindow.ui" line="45"/>
         <source>Task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="65"/>
+        <location filename="../ui/mainwindow.ui" line="66"/>
         <source>&amp;Variant:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="78"/>
+        <location filename="../ui/mainwindow.ui" line="79"/>
         <source>Number of variant</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="88"/>
+        <location filename="../ui/mainwindow.ui" line="89"/>
         <source>&amp;Cities:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="101"/>
+        <location filename="../ui/mainwindow.ui" line="102"/>
         <source>Number of cities</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="129"/>
+        <location filename="../ui/mainwindow.ui" line="130"/>
         <source>Cost of travel from city to city</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="157"/>
+        <location filename="../ui/mainwindow.ui" line="158"/>
         <source>Fill table with random numbers</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="160"/>
+        <location filename="../ui/mainwindow.ui" line="161"/>
         <source>Random</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="174"/>
+        <location filename="../ui/mainwindow.ui" line="175"/>
         <source>Solve current task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="177"/>
+        <location filename="../ui/mainwindow.ui" line="178"/>
         <source>Solve</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="191"/>
+        <location filename="../ui/mainwindow.ui" line="192"/>
         <source>Solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="200"/>
+        <location filename="../ui/mainwindow.ui" line="201"/>
         <source>Solution steps</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="221"/>
-        <location filename="../ui/mainwindow.ui" line="424"/>
+        <location filename="../ui/mainwindow.ui" line="222"/>
+        <location filename="../ui/mainwindow.ui" line="425"/>
         <source>Save solution to a file</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="224"/>
+        <location filename="../ui/mainwindow.ui" line="225"/>
         <source>Save Solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="251"/>
+        <location filename="../ui/mainwindow.ui" line="252"/>
         <source>Go back to Task tab</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="254"/>
+        <location filename="../ui/mainwindow.ui" line="255"/>
         <source>Back to Task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="284"/>
+        <location filename="../ui/mainwindow.ui" line="285"/>
         <source>&amp;File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="316"/>
+        <location filename="../ui/mainwindow.ui" line="317"/>
         <source>&amp;Language</source>
         <comment>Please, append &quot; / Language&quot; when translating this string.</comment>
